<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.1                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Build: 529     Patch: 10                                                 |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Templates
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function AdminManageTemplates
 * A function to manage templates 
 * @author Philipp Louis Esselbach
 */
function AdminManageTemplates( $opts )
{
	global $database, $system, $html, $ipaddr, $security, $preferences, $words_templates;
	$options = explode( "-", $opts );
	$options[ 0 ] = ( isset( $options[ 0 ] ) ) ? $security -> checkvar( $options[ 0 ] ) : "" ;
	$options[ 1 ] = ( isset( $options[ 1 ] ) ) ? $security -> checknum( $options[ 1 ] ) : "" ;
	$options[ 2 ] = ( isset( $options[ 2 ] ) ) ? $security -> checkvar( $options[ 2 ] ) : "" ;
	$options[ 3 ] = ( isset( $options[ 3 ] ) ) ? $security -> checkvar( $options[ 3 ] ) : "" ;
	
	if( $options[ 0 ] )
	{
		if( ( $system -> adminhashget() != $options[ 2 ] ) and( $preferences[ 'website_subsessions_admin' ] ) )
		{
			$html -> login( $words_templates[ 'ERROR' ], $words_templates[ 'INVALID_SESSION' ], "index.php" );
			exit;
		}
	}

	if( $options[ 0 ] == "previewtemplate" )
	{
		$query = $database -> dbquery( "SELECT template_name, template_html FROM " . DB_PREFIX . "esselbach_ct_templates WHERE template_id = '" . $options[ 1 ] . "'" );
		list( $template_name, $template_html ) = $database -> dbrow( $query );
		$html -> makeheader( $words_templates[ 'PREVIEW' ] );
		$template_output = str_replace( "\n", "<br />", htmlspecialchars( $template_html ) );
		$template_html = str_replace( "img src=\"", "img src=\"../", $template_html );
		$html -> makepopheader( $words_templates[ 'PREVIEW' ], "preview" );
		echo "<table><tbody><td>" . $template_html . "</td></tbody></table>";
		$html -> makemainsub( $words_templates[ 'HTML_OUTPUT' ] );
		echo $template_output;
		$html -> makemainsub( "" );
		echo "<div style=\"text-align: center;\">[<a href=\"javascript:self.close()\">" . $words_templates[ 'CLOSE_WINDOW' ] . "</a>]</div>";
		$html -> makemainfooter();
		$html -> makefooter();
	}

	if( $options[ 0 ] == "restoretemplate" )
	{
		$query = $database -> dbquery( "SELECT templateundo_template, templateundo_html, templateundo_php, templateundo_date FROM " . DB_PREFIX . "esselbach_ct_templatesundo WHERE templateundo_id = '" . $options[ 1 ] . "'" );
		list( $templateundo_template, $templateundo_html, $templateundo_php, $templateundo_date ) = $database -> dbrow( $query );
		$query = $database -> dbquery( "SELECT template_html, template_php, template_date FROM " . DB_PREFIX . "esselbach_ct_templates WHERE template_id = '" . $templateundo_template . "'" );
		list( $template_html, $template_php, $template_date ) = $database -> dbrow( $query );
		$template_restore_date = mktime();
		$templateundo_date = date( "dS F Y h:i:s A", $templateundo_date );
		$template_html = $database -> dbescape( $template_html );
		$template_php = $database -> dbescape( $template_php );
		$templateundo_html = $database -> dbescape( $templateundo_html );
		$templateundo_php = $database -> dbescape( $templateundo_php );
		$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_templatesundo (templateundo_id, templateundo_template, templateundo_html, templateundo_php, templateundo_date, templateundo_ip, templateundo_editreason) VALUES (NULL, '" . $templateundo_template . "', '" . $template_html . "', '" . $template_php . "', '" . $template_date . "', '" . $ipaddr . "', '" . $database -> dbescape( $words_templates[ 'RESTORED_FROM' ] ) . " " . $templateundo_date . "')" );
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_templates SET template_html = '" . $templateundo_html . "', template_php = '" . $templateundo_php . "', template_date = '" . $template_restore_date . "', template_editreason = '" . $database -> dbescape( $words_templates[ 'RESTORED_FROM' ] ) . " " . $templateundo_date . "', template_editip = '" . $ipaddr . "' WHERE template_id = '" . $templateundo_template . "'" );
		AdminManageTemplates( "edittemplate-" . $templateundo_template . "-" . $options[ 2 ] );
	}

	if( $options[ 0 ] == "showundotemplate" )
	{
		$query = $database -> dbquery( "SELECT templateundo_html, templateundo_php FROM " . DB_PREFIX . "esselbach_ct_templatesundo WHERE templateundo_id = '" . $options[ 1 ] . "'" );
		list( $templateundo_html, $templateundo_php ) = $database -> dbrow( $query );
		$html -> makeheader( $words_templates[ 'OLDER_TEMPLATE_VERSION' ] );
		$html -> makepopheader( $words_templates[ 'HTML_PART' ], "oldtemplate" );
		echo "<textarea cols=\"70\" rows=\"12\">" . htmlspecialchars( $templateundo_html ) . "</textarea>";
		$html -> makemainsub( $words_templates[ 'PHP_PART' ] );
		echo "<textarea cols=\"70\" rows=\"12\">" . htmlspecialchars( $templateundo_php ) . "</textarea>";
		$html -> makemainsub( "" );
		echo "<div style=\"text-align: center;\">[<a href=\"javascript:self.close()\">" . $words_templates[ 'CLOSE_WINDOW' ] . "</a>]</div>";
		$html -> makemainfooter();
		$html -> makefooter();
	}

	if( $options[ 0 ] == "addtemplate" )
	{
		$html -> makeheader( $words_templates[ 'CREATE_NEW_TEMPLATE' ] );
		$html -> forminit( "extra_form_close", "extra_form_open" );
		
		if( $preferences[ 'templates_editor' ] )
		{
			$html -> codeinit();
		}
		
		$html -> makesubheader();
		$html -> makegroupmenu( "templates" );
		$html -> makeformheader( $words_templates[ 'CREATE_NEW_TEMPLATE' ], "add", "addform", "post" );
		$html -> uppertext( $words_templates[ 'TEMPLATE_NAME' ], "input_template_name", "" );
		
		if( !$preferences[ 'templates_editor' ] )
		{
			$html -> upperform( $words_templates[ 'HTML_PART' ], "input_template_html", "", 25 );
			echo "<div id=\"extra_form_close\"><a href=\"#\" onclick=\"show_form(); return false;\">" . $words_templates[ 'ADD_PHP_TO_TEMPLATE' ] . "</a></div>";
			echo "<div id=\"extra_form_open\" style=\"display:none\">";
			$html -> upperform( $words_templates[ 'PHP_PART' ], "input_template_php", "", 25 );
			echo "</div>";
		}
		else
		{
			$html -> upperformcode( $words_templates[ 'HTML_PART' ], "input_template_html", "", 25, "html" );
			$html -> upperformcode( $words_templates[ 'PHP_PART' ], "input_template_php", "", 25, "php" );
		}
		
		echo "<input type=\"hidden\" name=\"input_security_hash\" value=\"" . $options[ 2 ] . "\" /><input type=\"hidden\" name=\"aform\" value=\"doaddtemplate\" /><input type=\"hidden\" name=\"input_template_set\" value=\"" . $options[ 1 ] . "\" /><input type=\"submit\" value=\"" . $words_templates[ 'SUBMIT' ] . "\" />";
		$html -> makeformfooter();
	}

	if( $options[ 0 ] == "edittemplate" )
	{
		$query = $database -> dbquery( "SELECT template_set, template_name, template_html, template_php, template_date FROM " . DB_PREFIX . "esselbach_ct_templates WHERE template_id = '" . $options[ 1 ] . "'" );
		list( $template_set, $template_name, $template_html, $template_php, $template_date ) = $database -> dbrow( $query );
		$html -> makeheader( $words_templates[ 'EDIT_TEMPLATE' ] . " " . $template_name );
		$html -> forminit( "extra_form_close", "extra_form_open" );
		$html -> popinit();
		
		if( $preferences[ 'templates_editor' ] )
		{
			$html -> codeinit();
		}
		
		$html -> makesubheader();
		$html -> makegroupmenu( "templates" );
		$html -> makeformheader( $words_templates[ 'EDIT_TEMPLATE' ] . " " . $template_name, "edit", "editform", "post" );
		$template_date = date( "dS F Y h:i:s A", $template_date );
		
		$query = $database -> dbquery( "SELECT templateset_name FROM " . DB_PREFIX . "esselbach_ct_templatesets WHERE templateset_id = '" . $template_set . "'");
		list( $templateset_name ) = $database -> dbrow( $query );
		echo "<a href=\"index.php?action=managetemplates\">" . $words_templates[ 'TEMPLATES' ] . "</a> &#187; <a href=\"index.php?action=managetemplates&amp;opts=showtemplates-" . $template_set . "-" . $options[ 2 ] . "\">" . htmlspecialchars( $templateset_name ) . "</a>";
		$template_split = explode( "_", $template_name );
		echo " &#187; <a href=\"index.php?action=managetemplates&amp;opts=showtemplates-" . $template_set . "-" . $options[ 2 ] . "-" . htmlspecialchars( $template_split[ 0 ] ) ."\">" . htmlspecialchars( $template_split[ 0 ] ) . "</a>";				echo " &#187; <a href=\"index.php?action=managetemplates&amp;opts=edittemplate-" . $options [ 1 ] . "-" . $options[ 2 ] ."\">" . htmlspecialchars( $template_name ) . "</a>";	
		echo "<br /><br />";
		
		if( !$preferences[ 'templates_editor' ] )
		{
			$html -> upperform( $words_templates[ 'HTML_PART' ], "input_template_html", $template_html, 25 );
			
			if( $template_php )
			{
				echo "<div id=\"extra_form_open\">";
			}
			else
			{
				echo "<div id=\"extra_form_close\"><a href=\"#\" onclick=\"show_form(); return false;\">" . $words_templates[ 'ADD_PHP_TO_TEMPLATE' ] . "</a></div>";
				echo "<div id=\"extra_form_open\" style=\"display:none\">";
			}
			
			$html -> upperform( $words_templates[ 'PHP_PART' ], "input_template_php", $template_php, 25 );
			echo "</div>";
		}
		else
		{
			$html -> upperformcode( $words_templates[ 'HTML_PART' ], "input_template_html", $template_html, 25, "html" );
			$html -> upperformcode( $words_templates[ 'PHP_PART' ], "input_template_php", $template_php, 25, "php" );
		}
		
		$html -> upperform( $words_templates[ 'REASON_FOR_EDIT' ], "input_edit_reason", "" , 2 );
		echo "<input type=\"hidden\" name=\"input_security_hash\" value=\"" . $options[ 2 ] . "\" /><input type=\"hidden\" name=\"aform\" value=\"doedittemplate\" /><input type=\"hidden\" name=\"input_template_id\" value=\"" . $options[ 1 ] . "\" />" . $words_templates[ 'TEMPLATE_LAST_SAVED' ] . " " . $template_date . "<br /><input type=\"submit\" value=\"" . $words_templates[ 'SUBMIT' ] . "\" onclick=\"codesubmit();\" /><br /><br />";
		
		if( $preferences[ 'templates_undo' ] )
		{
			$query = $database -> dbquery( "SELECT templateundo_id, templateundo_editreason, templateundo_date FROM " . DB_PREFIX . "esselbach_ct_templatesundo WHERE templateundo_template = '" . $options[ 1 ] . "' ORDER BY templateundo_date DESC LIMIT 25" );
			
			if( $database -> dbrows( $query ) )
			{
				$html -> tworowstable( $words_templates[ 'OLDER_VERSIONS' ], "" );
				
				while( list( $templateundo_id, $templateundo_editreason, $templateundo_date ) = $database -> dbrow( $query ) )
				{
					$templateundo_date = date( "dS F Y h:i:s A", $templateundo_date );
					$html -> simpletablemiddleundo( $templateundo_editreason . " (" . $templateundo_date . ")", "javascript:pop_win('index.php?action=managetemplates&amp;opts=showundotemplate-" . $templateundo_id . "-" . $options[ 2 ] . "')", "index.php?action=managetemplates&amp;opts=restoretemplate-" . $templateundo_id . "-" . $options[ 2 ] );
				}
				
				$html -> maketablefooter();
			}
		}
		
		$html -> makeformfooter();
	}

	if( $options[ 0 ] == "deletetemplates" )
	{
		$query = $database -> dbquery( "SELECT templateset_id FROM " . DB_PREFIX . "esselbach_ct_templatesets WHERE templateset_id = '" . $options[ 1 ] . "'" );
		
		if( $database -> dbrow( $query ) )
		{
			$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_templatesets WHERE templateset_id = '" . $options[ 1 ] . "'" );
			$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_templates WHERE template_set = '" . $options[ 1 ] . "'" );
			$html -> login( $words_templates[ 'TEMPLATES' ], $words_templates[ 'SET_REMOVED' ], "index.php?action=managetemplates" );
		}
	}

	if( $options[ 0 ] == "showtemplates" )
	{
		$html -> makeheader( $words_templates[ 'TEMPLATES' ] );
		$html -> forminit( "extra_form_close", "extra_form_open" );
		$html -> popinit();
		
		if( $preferences[ 'templates_editor' ] )
		{
			$html -> codeinit();
		}
		
		$html -> makesubheader();
		$html -> makegroupmenu( "templates" );
		$html -> makeformheader( $words_templates[ 'SEARCH_TEMPLATES' ], "show", "showform", "post" );
		echo $words_templates[ 'SEARCH_FOR' ] . "<input type=\"hidden\" name=\"aform\" value=\"searchtemplates\" /><input name=\"input_search_for\" size=\"32\" /> ";
		echo $words_templates[ 'IN_TEMPLATE_SET' ] . " <select size=\"1\" name=\"input_template_set\">";
		$query = $database -> dbquery( "SELECT templateset_id, templateset_name FROM " . DB_PREFIX . "esselbach_ct_templatesets" );
		
		while( list( $templateset_id, $templateset_name ) = $database -> dbrow( $query ) )
		{
			( $templateset_id == $options[ 1 ] ) ? $checked = "selected=\"selected\"" : $checked = "";
			echo "<option $checked value=\"" . $templateset_id . "\">" . $templateset_name . "</option>";
		}
		
		echo "</select><input type=\"submit\" value=\"" . $words_templates[ 'SUBMIT' ] . "\" /><br /><br />";
		echo "<a href=\"index.php?action=managetemplates&amp;opts=addtemplate-" . $options[ 1 ] . "-" . $options[ 3 ] . "\">" . $words_templates[ 'CLICK_HERE' ] . "</a> " . $words_templates[ 'TO_CREATE_A_NEW_TEMPLATE' ] . "<br /><br />";
	
		$query = $database -> dbquery( "SELECT templateset_name FROM " . DB_PREFIX . "esselbach_ct_templatesets WHERE templateset_id = '" . $options[ 1 ] . "'");
		list( $templateset_name ) = $database -> dbrow( $query );
		echo "<h1>" . $words_templates[ 'TEMPLATE_SETS' ] . " " . htmlspecialchars( $templateset_name ) . "</h1>";
		
		echo "<a href=\"index.php?action=managetemplates\">" . $words_templates[ 'TEMPLATES' ] . "</a> &#187; <a href=\"index.php?action=managetemplates&amp;opts=showtemplates-" . $options[ 1 ] . "-" . $options[ 2 ] . "\">" . htmlspecialchars( $templateset_name ) . "</a>";
		
		if ( $options[ 3 ] )
		{
			echo " &#187; <a href=\"index.php?action=managetemplates&amp;opts=showtemplates-" . $options[ 1 ] . "-" . $options[ 2 ] . "-" . $options[ 3 ] ."\">" . $options[ 3 ] . "</a>";			
		}		
		
		echo "<br /><br />";
		
		$query = $database -> dbquery( "SELECT templatecat_name, templatecat_desc FROM " . DB_PREFIX . "esselbach_ct_templatescat" );
		
		while( list( $templatecat_name, $templatecat_desc ) = $database -> dbrow( $query ) )
		{
			$template_category_description[ strtoupper( $templatecat_name ) ] = $templatecat_desc;
		}
		
		$templates_in_category = 0;
		
		if( $options[ 3 ] )
		{
			$query = $database -> dbquery( "SELECT template_id, template_name FROM " . DB_PREFIX . "esselbach_ct_templates WHERE template_set = '" . $options[ 1 ] . "' AND (template_name LIKE '" . $options[ 3 ] . "%') ORDER BY template_name" );
		}
		else
		{
			$query = $database -> dbquery( "SELECT template_id, template_name FROM " . DB_PREFIX . "esselbach_ct_templates WHERE template_set = '" . $options[ 1 ] . "' ORDER BY template_name" );
		}
		
		if( $database -> dbrows( $query ) )
		{
			$html -> tworowstable( "", "" );
			$old_template_category[ 0 ] = "";
			
			while( list( $template_id, $template_name ) = $database -> dbrow( $query ) )
			{
				$template_category = explode( "_", $template_name );
				
				if( $template_category[ 0 ] != $old_template_category[ 0 ] )
				{
					if( $old_template_category[ 0 ] )
					{
						$html -> simpletablemiddleeditonly( $templates_in_category . " " . $words_templates[ '_TEMPLATES' ], "index.php?action=managetemplates&amp;opts=showtemplates-" . $options[ 1 ] . "-" . $options[ 2 ] . "-" . strtolower( $old_template_category[ 0 ] ) );
						$templates_in_category = 0;
					}
					
					$template_category_output = strtoupper( $template_category[ 0 ] );
					( isset( $template_category_description[ $template_category_output ] ) ) ? $template_description_output = $template_category_description[ $template_category_output ] : $template_description_output = $words_templates[ 'NO_DESCRIPTION_AVAILABLE' ];
					echo <<<Middle
	<tr>
	  <td class="table1">      	
		<strong>$template_category_output</strong>
		<br />  	
		$template_description_output      
      </td>
	  <td class="table1">      	
		<br />  	   
      </td>      
	</tr>                    
Middle;
				}
				
				if( $options[ 3 ] )
				{
					$html -> simpletablemiddlepreview( $template_name, "index.php?action=managetemplates&amp;opts=edittemplate-" . $template_id . "-" . $options[ 2 ], "javascript:pop_win('index.php?action=managetemplates&amp;opts=previewtemplate-" . $template_id . "-" . $options[ 2 ] . "')" );
				}
				else
				{
					$templates_in_category++;
				}
				
				$old_template_category = explode( "_", $template_name );
			}
			
			if( !$options[ 3 ] )
			{
				$html -> simpletablemiddleeditonly( $templates_in_category . " " . $words_templates[ '_TEMPLATES' ], "index.php?action=managetemplates&amp;opts=showtemplates-" . $options[ 1 ] . "-" . $options[ 2 ] . "-" . strtolower( $old_template_category[ 0 ] ) );
			}
			
			$html -> maketablefooter();
		}
		
		$html -> makesubfooter();
		$html -> makesubfooter();
	}

	if( !$options[ 0 ] )
	{
		$security_hash = $system -> adminhashput();
		
		$html -> makeheader( $words_templates[ 'MANAGE_TEMPLATES' ] );
		$html -> deleteinit( $words_templates[ 'ARE_YOU_SURE' ] );
		$html -> makesubheader();
		$html -> makegroupmenu( "templates" );
		$html -> makemainheader( $words_templates[ 'MANAGE_TEMPLATES' ], "templates" );
		$html -> tableheader( $words_templates[ 'TEMPLATE_SETS_ID' ], $words_templates[ 'TEMPLATE_SETS' ] );
		$query = $database -> dbquery( "SELECT templateset_id, templateset_name FROM " . DB_PREFIX . "esselbach_ct_templatesets ORDER BY templateset_id" );
		
		if( $database -> dbrows( $query ) )
		{
			while( list( $templateset_id, $templateset_name ) = $database -> dbrow( $query ) )
			{
				$html -> tablemiddle( $templateset_id, $templateset_name, "managetemplates&amp;opts=showtemplates-" . $templateset_id . "-" . $security_hash, "managetemplates&amp;opts=deletetemplates-" . $templateset_id . "-" . $security_hash );
			}
		}
		
		$html -> maketablefooter();
		$html -> makemainsubform( $words_templates[ 'CREATE_NEW_SET' ] );
		$html -> makeeoption( $words_templates[ 'NEW_SET_NAME' ], "input_new_set_name", "" );
		$query = $database -> dbquery( "SELECT templateset_id, templateset_name FROM " . DB_PREFIX . "esselbach_ct_templatesets" );
		echo $words_templates[ 'USING_TEMPLATE_SET' ] . " <select size=\"1\" name=\"input_import_set\">";
		
		while( list( $templateset_id, $templateset_name ) = $database -> dbrow( $query ) )
		{
			echo "<option value=\"" . $templateset_id . "\">" . $templateset_name . "</option>";
		}
		
		echo "</select> ";
		$query = $database -> dbquery( "SELECT templatelang_id, templatelang_name FROM " . DB_PREFIX . "esselbach_ct_templateslangs" );
		echo $words_templates[ 'AND_LANGUAGE' ] . " <select size=\"1\" name=\"input_import_lang\">";
		echo "<option value=\"0\">" . $words_templates[ 'DEFAULT' ] . "</option>";
		
		while( list( $templatelang_id, $templatelang_name ) = $database -> dbrow( $query ) )
		{
			echo "<option value=\"" . $templatelang_id . "\">" . $templatelang_name . "</option>";
		}
		
		echo "</select> ";
		echo "<input type=\"hidden\" name=\"input_security_hash\" value=\"" . $security_hash . "\" /><input type=\"hidden\" name=\"aform\" value=\"doaddset\" /><input type=\"submit\" value=\"" . $words_templates[ 'SUBMIT' ] . "\" />";
		$html -> makeformfooter();
	}
}
?>